=== debian/changelog ===
spirv-tools (2020.6-2) unstable; urgency=medium

  * rules: Really build for the static library, and make sure shared one
    is removed since it's still created despite the config options.
    (Closes: #980370)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 21 Jul 2021 10:15:48 +0300

spirv-tools (2020.6-1) unstable; urgency=medium

  * New upstream release. (Closes: #975164)
  * control: Bump spirv-headers build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 09 Dec 2020 00:07:00 +0200
