=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-tools-$1.tar.gz%" \
   https://github.com/KhronosGroup/spirv-tools/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
