## spirv-tools 2021.2%2Bgit20210818

=== debian/changelog ===
spirv-tools (2021.2+git20210818-1~mx21ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 23 Aug 2021 10:23:15 -0400

spirv-tools (2021.2+git20210818-1) unstable; urgency=medium

  [ Hill Ma ]
  * control: Fix Vcs-Git and Vcs-Browser.

  [ Timo Aaltonen ]
  * New upstream snapshot.
  * control: Bump spirv-headers dependency.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 18 Aug 2021 16:30:03 +0300
