=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: spirv-tools
 Section: libdevel
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
  python3-dev,
