## spirv-tools 2021.4

=== debian/changelog ===
spirv-tools (2021.4-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump spirv-headers build-dep.
  * control: Build-depend on python3:native instead of python3-dev.
    (Closes: #979078)

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 07 Jan 2022 11:46:18 +0200
