=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
- python3-dev,
- spirv-headers (>= 1.5.4+rt3-1~),
+ python3:native,
+ spirv-headers (>= 1.5.5),
 Standards-Version: 4.5.0
 Homepage: https://github.com/KhronosGroup/SPIRV-Tools
 Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/spirv-tools.git
