=== debian/changelog ===
spirv-tools (2022.1+1.3.204.0-2) unstable; urgency=medium

  * disable-shared-harder.diff: Modify the build to actually disable
    building a shared library and what it brings.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 16 Feb 2022 18:37:15 +0200

spirv-tools (2022.1+1.3.204.0-1) unstable; urgency=medium

  * New upstream snapshot based on sdk-1.3.204.0 tag.
  * control: Bump spirv-headers build-dependency.
  * contro: Bump debhelper-compat to 13, policy to 4.6.0.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 16 Feb 2022 14:55:24 +0200
