=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libdevel
 Priority: optional
 Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  cmake,
  python3:native,
- spirv-headers (>= 1.5.5),
-Standards-Version: 4.5.0
+ spirv-headers (>= 1.6.1),
+Standards-Version: 4.6.0
 Homepage: https://github.com/KhronosGroup/SPIRV-Tools
 Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/spirv-tools.git
 Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/spirv-tools
