=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,6 @@
 
 %:
 	dh $@ 
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -18,8 +15,6 @@
 
 override_dh_install:
 	dh_install
-	rm debian/spirv-tools/usr/lib/*/pkgconfig/SPIRV-Tools-shared.pc
-	rm debian/spirv-tools/usr/lib/*/libSPIRV-Tools-shared.so
 
 
 gentarball: SOURCE=spirv-tools
