## spirv-tools 2022.2+1.3.216.0

=== debian/changelog ===
spirv-tools (2022.2+1.3.216.0-1) unstable; urgency=medium

  * New upstream snapshot based on sdk-1.3.216.0 tag.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 30 Jun 2022 12:15:43 +0300
