=== debian/changelog ===
spirv-tools (2022.3-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 25 Aug 2022 18:21:49 +0300
