## spirv-tools 2022.4

=== debian/changelog ===
spirv-tools (2022.4-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-dep on spirv-headers.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 08 Nov 2022 11:15:14 +0200
