## spirv-tools 2022.4+1.3.236.0

=== debian/changelog ===
spirv-tools (2022.4+1.3.236.0-1) unstable; urgency=medium

  * New upstream snapshot from sdk-1.3.236.0 tag.
  * control: Bump build-dep on spirv-headers.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 18 Jan 2023 12:13:00 +0200
